//--------------------------------------------------------------------------------
// SIGNALISATION
//----------------------------------------------------------------------------------
/*
void sig(byte sig, byte state);
byte sig(byte sig);
void sig_aig(byte sig, byte state_aig);
byte sig_aig(byte sig);
void sig_dir(byte sig, byte dir);
void sig_cli(byte sig, byte cli);
void sig_next(byte sig, byte next_sig);
byte sig_next(byte sig);
*/


//--------------------------------------------------------------------------------
// partie utilisateur (UU: voir si on la deplace dans le main ino)
//----------------------------------------------------------------------------------

#define NB_SIG 16   // nombre max de signaux (on peut en avoir moins)

// nom des signaux
#define C101 0
#define S1   1
#define S2   2
#define DSK1 3   //pas D1 car sortie 1 de l'arduino
#define S3   3

// >C101 ---AIGs---- ---- >S1 ----- >S2

// ---GARE--- >S3 ---- DSK1< ---VU----

// etat des signaux (pour la France, peut ete modifie pour d'autres pays)
#define SIG_0      0    // cible eteinte (etat par defaut)
#define SIG_VL     1 
#define SIG_VL_CLI 2 
#define SIG_M      3 
#define SIG_M_CLI  4 
#define SIG_A      5 
#define SIG_A_CLI  6 
#define SIG_S      7 
#define SIG_S_CLI  8
#define SIG_C      9 
#define SIG_CV     9
#define SIG_D      9

// second etat (souvent utilise pour les bifurcations)
//#define SIG_0    0  //commenté car déja définit 
#define SIG_R      1 
#define SIG_RR     2 
#define SIG_R_CLI  3 
#define SIG_RR_CLI 4 


// normalement pas besoin d'utiliser
void user_sig_init(void)
{
}


// normalement pas besoin d'utiliser
void user_sig_250ms(void)
{
}


// mise a jour des leds/sevos en fonction des etats
void user_notify_sig(byte num, byte state, byte state_aig, byte dir, byte cli)
{
#if 0
    // ex: semaphore sur leds du SPI local
    if(num == S1)
    {
        user_led(10, state==SIG_VL);
        user_led(11, state==SIG_S);
        user_led(12, state==SIG_A);
    }        
    // ex: carré sur leds d'un decodeur d'accessoires distant
    if(num == C101)
    {
        user_bas_acc_dec_tx(20, 0, state==SIG_C);
        user_bas_acc_dec_tx(20, 1, state==SIG_VL);
        user_bas_acc_dec_tx(20, 2, state==SIG_S || state==SIG_C);
        user_bas_acc_dec_tx(20, 3, state==SIG_A);
        
        user_bas_acc_dec_tx(20, 4, state_aig==(SIG_RR | SIG_RR_CLI));
        user_bas_acc_dec_tx(20, 5, state_aig==(SIG_RR | SIG_RR_CLI));
        user_bas_acc_dec_tx(20, 6, state_aig==(SIG_R  | SIG_R_CLI));
        user_bas_acc_dec_tx(20, 7, state_aig==(SIG_R  | SIG_R_CLI));
    }        
    // ex: disque
    if(num == DSK1)
    {
        user_led(100, state==SIG_VL);
        user_led(101, state==SIG_D);
        user_led(102, state==SIG_D);
        user_led(103, state==SIG_A);
    }        
#endif    
}


// calcul de l'etat de tous les feux (toutes les 250ms)
// penser a mettre des yield() de temps en temps si trop long
void user_sig_update(void)
{
#if 0
    //---------- 0) init en etat inconnu
    
    sig(C101, SIG_0);
    sig(S1  , SIG_0);
    sig(DSK1, SIG_0);


    //---------- 1) mise a jour des "rouges" (ne dependent pas des autres siganux, mais des iti, bmvu, commandes manuelles, detections) ----------
    
    // NF: carré, carré violet (dependent souvent des itineraires)
    if(user_get_u(60)) sig(C101 , SIG_C);

    // NF: semphore de voie unique (dependent souvent du bmvu ou commandes manuelles)
    if(user_get_u(87)) sig(S3 , SIG_S);  //shem BM
    
    // F: sémaphore (souvent en fonction des detections)
    if(sig(C101) == SIG_0)
    {
        if(user_get_u(20)) if(user_get_in(1) || user_get_in(2) || user_get_in(3)) sig(C101 , SIG_S); /* iti 1, canton d'arrivé aussi prit en compte */
        if(user_get_u(20)) sig_next(C101, S1);
        // ... si autres itineraires
    }
    if(user_get_in(1)) sig(S1, SIG_S);

    // F: disque (souvent en fonction de l'aubinage)
    if(user_get_u(16)) sig(DSK1 , SIG_D);


    //---------- 2) mise a jour des "jaunes" (dans un second temps car dependent des rouges d'autres signaux) ----------
    
    // F: avertissement (depend souvent des feux precedent)
    if(sig(C101) == SIG_0) { byte s = sig_next(C101); if(sig(s) == SIG_S) sig(C101, SIG_A); }
    if(sig(S1)   == SIG_0) if(sig(S2) == SIG_S) sig(S1, SIG_A);
    if(sig(DSK1) == SIG_0) if(sig(S3) != SIG_VL) sig(DSK1, SIG_A);


    //---------- 3) mise a jour des "verts" pour tous les signaux encore en etat inconnu
     
    // F: VLCLI
    if(sig(C101) == SIG_0) sig(C101, SIG_VL);
    if(sig(S1)   == SIG_0) sig(S1, SIG_VL);
    if(sig(DSK1) == SIG_0) sig(DSK1, SIG_VL);
        
    // F: M, MCLI


    //---------- 4) rajout des etats secondaires de deviations 

    // rajout RR

    // rajout R

    // rajout direction
#endif 0
}



//--------------------------------------------------------------------------------
// SIGNALISATION
//----------------------------------------------------------------------------------

class C_sig
{
    public:
        byte state         = SIG_0;
        byte state_aig     = SIG_0;
        byte old_state     = SIG_0;
        byte old_state_aig = SIG_0;
        byte next_sig      = 255;
        byte cli           = 0; //si besoin d'un clignotement different de celui des cli  des leds
        byte dir           = 0; //0=aucune direction,  1pour direction1 ...
        byte old_dir       = 0; //aucune
};
C_sig sigs[NB_SIG];

//void sig_init(void)
//{
//    user_sig_init();
//}

byte sig_initialized = 0;
void sig_update(void)
{
    if(sig_initialized == 0) user_sig_init();
    
    user_sig_update();
    
    for(byte sig = 0; sig < NB_SIG; sig++)
    {
        if(   (sigs[sig].state != sigs[sig].old_state) 
           || (sigs[sig].state_aig != sigs[sig].old_state_aig)
           || (sigs[sig].dir != sigs[sig].old_dir)
           || sigs[sig].cli
           || (sig_initialized==0) )
        {
            user_notify_sig(sig, sigs[sig].state, sigs[sig].state_aig, sigs[sig].dir, sigs[sig].cli);    
            sigs[sig].old_state = sigs[sig].state;
            sigs[sig].old_state_aig = sigs[sig].state_aig;
            sigs[sig].old_dir = sigs[sig].dir;
        }        
    }
    sig_initialized=1;

    user_sig_250ms();
}

void sig(byte sig, byte state); byte sig(byte sig);
void sigrrr(byte sig, byte state); byte sigrrr(byte sig);

void sig(byte sig, byte state)
{
    sigs[sig].state = state;
}

byte sig(byte sig)
{
    return sigs[sig].state;
}

void sig_aig(byte sig, byte state_aig)  //UU: faire des versions plus intlligentes (ne pas faire de R si RR mais faire A, ne pas faire suivant etat du state pas aig)
{
    sigs[sig].state_aig = state_aig;
}

byte sig_aig(byte sig)
{
    return sigs[sig].state_aig;
}

void sig_dir(byte sig, byte dir)
{
    sigs[sig].dir = dir;
}

void sig_cli(byte sig, byte cli)
{
    sigs[sig].cli = cli;
}

void sig_next(byte sig, byte next_sig)
{
    sigs[sig].next_sig = next_sig;
}

byte sig_next(byte sig)
{
    return sigs[sig].next_sig;
}
